"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.definedTypeNodeFromIdl = exports.definedTypeNode = void 0;
const shared_1 = require("../shared");
const TypeNode_1 = require("./typeNodes/TypeNode");
function definedTypeNode(input) {
    var _a, _b;
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('DefinedTypeNode must have a name.');
    }
    return {
        kind: 'definedTypeNode',
        name: (0, shared_1.mainCase)(input.name),
        type: input.type,
        idlName: (_a = input.idlName) !== null && _a !== void 0 ? _a : input.name,
        docs: (_b = input.docs) !== null && _b !== void 0 ? _b : [],
    };
}
exports.definedTypeNode = definedTypeNode;
function definedTypeNodeFromIdl(idl) {
    var _a, _b;
    const name = (_a = idl.name) !== null && _a !== void 0 ? _a : '';
    const idlType = (_b = idl.type) !== null && _b !== void 0 ? _b : { kind: 'struct', fields: [] };
    const type = (0, TypeNode_1.createTypeNodeFromIdl)(idlType);
    return definedTypeNode({ name, type, idlName: name, docs: idl.docs });
}
exports.definedTypeNodeFromIdl = definedTypeNodeFromIdl;
//# sourceMappingURL=DefinedTypeNode.js.map