"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorNodeFromIdl = exports.errorNode = void 0;
const shared_1 = require("../shared");
function errorNode(input) {
    var _a, _b;
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('ErrorNode must have a name.');
    }
    if (input.code < 0) {
        throw new shared_1.InvalidKinobiTreeError('ErrorNode must have a code number.');
    }
    return {
        kind: 'errorNode',
        name: (0, shared_1.mainCase)(input.name),
        idlName: (_a = input.idlName) !== null && _a !== void 0 ? _a : input.name,
        code: input.code,
        message: input.message,
        docs: (_b = input.docs) !== null && _b !== void 0 ? _b : [],
    };
}
exports.errorNode = errorNode;
function errorNodeFromIdl(idl) {
    var _a, _b, _c, _d;
    const name = (_a = idl.name) !== null && _a !== void 0 ? _a : '';
    const msg = (_b = idl.msg) !== null && _b !== void 0 ? _b : '';
    return errorNode({
        name,
        idlName: name,
        code: (_c = idl.code) !== null && _c !== void 0 ? _c : -1,
        message: msg,
        docs: (_d = idl.docs) !== null && _d !== void 0 ? _d : [msg ? `${name}: ${msg}` : `${name}`],
    });
}
exports.errorNodeFromIdl = errorNodeFromIdl;
//# sourceMappingURL=ErrorNode.js.map