"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.programNodeFromIdl = exports.programNode = void 0;
const shared_1 = require("../shared");
const AccountNode_1 = require("./AccountNode");
const DefinedTypeNode_1 = require("./DefinedTypeNode");
const ErrorNode_1 = require("./ErrorNode");
const InstructionNode_1 = require("./InstructionNode");
const PdaNode_1 = require("./PdaNode");
function programNode(input) {
    var _a, _b, _c, _d, _e, _f, _g;
    return {
        kind: 'programNode',
        pdas: ((_a = input.pdas) !== null && _a !== void 0 ? _a : []),
        accounts: ((_b = input.accounts) !== null && _b !== void 0 ? _b : []),
        instructions: ((_c = input.instructions) !== null && _c !== void 0 ? _c : []),
        definedTypes: ((_d = input.definedTypes) !== null && _d !== void 0 ? _d : []),
        errors: ((_e = input.errors) !== null && _e !== void 0 ? _e : []),
        name: (0, shared_1.mainCase)(input.name),
        prefix: (0, shared_1.mainCase)((_f = input.prefix) !== null && _f !== void 0 ? _f : ''),
        publicKey: input.publicKey,
        version: (_g = input.version) !== null && _g !== void 0 ? _g : '',
        origin: input.origin,
    };
}
exports.programNode = programNode;
function programNodeFromIdl(idl) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const origin = (_a = idl.metadata) === null || _a === void 0 ? void 0 : _a.origin;
    const pdas = ((_b = idl.accounts) !== null && _b !== void 0 ? _b : [])
        .filter((account) => { var _a; return ((_a = account.seeds) !== null && _a !== void 0 ? _a : []).length > 0; })
        .map(PdaNode_1.pdaNodeFromIdl);
    const accounts = ((_c = idl.accounts) !== null && _c !== void 0 ? _c : []).map(AccountNode_1.accountNodeFromIdl);
    const instructions = ((_d = idl.instructions) !== null && _d !== void 0 ? _d : []).map((ix) => {
        var _a;
        return origin === 'anchor'
            ? (0, InstructionNode_1.instructionNodeFromIdl)({
                ...ix,
                defaultOptionalAccounts: (_a = ix.defaultOptionalAccounts) !== null && _a !== void 0 ? _a : true,
            })
            : (0, InstructionNode_1.instructionNodeFromIdl)(ix);
    });
    return programNode({
        pdas,
        accounts,
        instructions,
        definedTypes: ((_e = idl.types) !== null && _e !== void 0 ? _e : []).map(DefinedTypeNode_1.definedTypeNodeFromIdl),
        errors: ((_f = idl.errors) !== null && _f !== void 0 ? _f : []).map(ErrorNode_1.errorNodeFromIdl),
        name: (_g = idl.name) !== null && _g !== void 0 ? _g : '',
        publicKey: (_j = (_h = idl.metadata) === null || _h === void 0 ? void 0 : _h.address) !== null && _j !== void 0 ? _j : '',
        version: (_k = idl.version) !== null && _k !== void 0 ? _k : '',
        origin,
    });
}
exports.programNodeFromIdl = programNodeFromIdl;
//# sourceMappingURL=ProgramNode.js.map