"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayTypeNodeFromIdl = exports.arrayTypeNode = void 0;
const countNodes_1 = require("../countNodes");
const NumberTypeNode_1 = require("./NumberTypeNode");
const TypeNode_1 = require("./TypeNode");
function arrayTypeNode(item, count) {
    return {
        kind: 'arrayTypeNode',
        item,
        count: (count !== null && count !== void 0 ? count : (0, countNodes_1.prefixedCountNode)((0, NumberTypeNode_1.numberTypeNode)('u32'))),
    };
}
exports.arrayTypeNode = arrayTypeNode;
function arrayTypeNodeFromIdl(idl) {
    if ('array' in idl) {
        const item = (0, TypeNode_1.createTypeNodeFromIdl)(idl.array[0]);
        return arrayTypeNode(item, (0, countNodes_1.fixedCountNode)(idl.array[1]));
    }
    const item = (0, TypeNode_1.createTypeNodeFromIdl)(idl.vec);
    if (!idl.size)
        return arrayTypeNode(item);
    if (idl.size === 'remainder')
        return arrayTypeNode(item, (0, countNodes_1.remainderCountNode)());
    return arrayTypeNode(item, (0, countNodes_1.prefixedCountNode)((0, NumberTypeNode_1.numberTypeNode)(idl.size)));
}
exports.arrayTypeNodeFromIdl = arrayTypeNodeFromIdl;
//# sourceMappingURL=ArrayTypeNode.js.map