"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.structFieldTypeNodeFromIdl = exports.structFieldTypeNode = void 0;
const shared_1 = require("../../shared");
const TypeNode_1 = require("./TypeNode");
function structFieldTypeNode(input) {
    var _a;
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('StructFieldTypeNode must have a name.');
    }
    return {
        kind: 'structFieldTypeNode',
        name: (0, shared_1.mainCase)(input.name),
        type: input.type,
        docs: (_a = input.docs) !== null && _a !== void 0 ? _a : [],
        defaultValue: input.defaultValue,
        defaultValueStrategy: input.defaultValueStrategy,
    };
}
exports.structFieldTypeNode = structFieldTypeNode;
function structFieldTypeNodeFromIdl(idl) {
    var _a, _b;
    return structFieldTypeNode({
        name: (_a = idl.name) !== null && _a !== void 0 ? _a : '',
        type: (0, TypeNode_1.createTypeNodeFromIdl)(idl.type),
        docs: (_b = idl.docs) !== null && _b !== void 0 ? _b : [],
    });
}
exports.structFieldTypeNodeFromIdl = structFieldTypeNodeFromIdl;
//# sourceMappingURL=StructFieldTypeNode.js.map