"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getProgramFragment = void 0;
const common_1 = require("./common");
function getProgramFragment(scope) {
    const { programNode, nameApi } = scope;
    const programErrorClass = nameApi.programErrorClass(programNode.name);
    const programErrorCode = nameApi.programErrorCodeEnum(programNode.name);
    const programGetErrorFromCodeFunction = nameApi.programGetErrorFromCodeFunction(programNode.name);
    const programFragment = (0, common_1.fragmentFromTemplate)('program.njk', {
        program: programNode,
        programType: nameApi.programType(programNode.name),
        programAddressConstant: nameApi.programAddressConstant(programNode.name),
        programCreateFunction: nameApi.programCreateFunction(programNode.name),
        programErrorClass,
        programErrorCode,
        programGetErrorFromCodeFunction,
    })
        .addImports('solanaAddresses', ['Address'])
        .addImports('solanaPrograms', ['Program']);
    if (programNode.errors.length > 0) {
        programFragment
            .addImports('solanaPrograms', ['ProgramWithErrors'])
            .addImports('generatedErrors', [
            programErrorClass,
            programErrorCode,
            programGetErrorFromCodeFunction,
        ]);
    }
    return programFragment;
}
exports.getProgramFragment = getProgramFragment;
//# sourceMappingURL=program.js.map