"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypeDiscriminatedUnionHelpersFragment = void 0;
const nodes_1 = require("../../../nodes");
const common_1 = require("./common");
function getTypeDiscriminatedUnionHelpersFragment(scope) {
    const { name, typeNode, nameApi } = scope;
    const isDiscriminatedUnion = (0, nodes_1.isNode)(typeNode, 'enumTypeNode') && (0, nodes_1.isDataEnum)(typeNode);
    if (!isDiscriminatedUnion) {
        return (0, common_1.fragment)('');
    }
    return (0, common_1.fragmentFromTemplate)('typeDiscriminatedUnionHelpers.njk', {
        strictName: nameApi.dataType(name),
        looseName: nameApi.dataArgsType(name),
        discriminatedUnionDiscriminator: nameApi.discriminatedUnionDiscriminator(name),
        getVariant: (variant) => nameApi.discriminatedUnionVariant(variant),
        discriminatedUnionFunction: nameApi.discriminatedUnionFunction(name),
        isDiscriminatedUnionFunction: nameApi.isDiscriminatedUnionFunction(name),
        typeNode,
    }).addImports('solanaCodecsDataStructures', [
        'GetDiscriminatedUnionVariantContent',
        'GetDiscriminatedUnionVariant',
    ]);
}
exports.getTypeDiscriminatedUnionHelpersFragment = getTypeDiscriminatedUnionHelpersFragment;
//# sourceMappingURL=typeDiscriminatedUnionHelpers.js.map