"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUniqueHashStringVisitor = void 0;
const json_stable_stringify_1 = __importDefault(require("json-stable-stringify"));
const staticVisitor_1 = require("./staticVisitor");
const removeDocsVisitor_1 = require("./removeDocsVisitor");
const mapVisitor_1 = require("./mapVisitor");
function getUniqueHashStringVisitor(options = {}) {
    var _a;
    const removeDocs = (_a = options.removeDocs) !== null && _a !== void 0 ? _a : false;
    if (!removeDocs) {
        return (0, staticVisitor_1.staticVisitor)((node) => (0, json_stable_stringify_1.default)(node));
    }
    return (0, mapVisitor_1.mapVisitor)((0, removeDocsVisitor_1.removeDocsVisitor)(), (node) => (0, json_stable_stringify_1.default)(node));
}
exports.getUniqueHashStringVisitor = getUniqueHashStringVisitor;
//# sourceMappingURL=getUniqueHashStringVisitor.js.map