"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setInstructionDiscriminatorsVisitor = void 0;
const nodes_1 = require("../nodes");
const bottomUpTransformerVisitor_1 = require("./bottomUpTransformerVisitor");
function setInstructionDiscriminatorsVisitor(map) {
    return (0, bottomUpTransformerVisitor_1.bottomUpTransformerVisitor)(Object.entries(map).map(([selector, discriminator]) => ({
        select: ['[instructionNode]', selector],
        transform: (node) => {
            var _a, _b, _c, _d, _e, _f;
            (0, nodes_1.assertIsNode)(node, 'instructionNode');
            const discriminatorArgument = (0, nodes_1.instructionArgumentNode)({
                name: (_a = discriminator.name) !== null && _a !== void 0 ? _a : 'discriminator',
                type: (_b = discriminator.type) !== null && _b !== void 0 ? _b : (0, nodes_1.numberTypeNode)('u8'),
                docs: (_c = discriminator.docs) !== null && _c !== void 0 ? _c : [],
                defaultValue: discriminator.value,
                defaultValueStrategy: (_d = discriminator.strategy) !== null && _d !== void 0 ? _d : 'omitted',
            });
            return (0, nodes_1.instructionNode)({
                ...node,
                discriminators: [
                    (0, nodes_1.fieldDiscriminatorNode)((_e = discriminator.name) !== null && _e !== void 0 ? _e : 'discriminator'),
                    ...((_f = node.discriminators) !== null && _f !== void 0 ? _f : []),
                ],
                arguments: [discriminatorArgument, ...node.arguments],
            });
        },
    })));
}
exports.setInstructionDiscriminatorsVisitor = setInstructionDiscriminatorsVisitor;
//# sourceMappingURL=setInstructionDiscriminatorsVisitor.js.map