import { IdlInstructionAccount } from '../idl';
import { MainCaseString, PartialExcept } from '../shared';
import { InstructionInputValueNode } from './contextualValueNodes';
export interface InstructionAccountNode<TDefaultValue extends InstructionInputValueNode | undefined = InstructionInputValueNode | undefined> {
    readonly kind: 'instructionAccountNode';
    readonly defaultValue?: TDefaultValue;
    readonly name: MainCaseString;
    readonly isWritable: boolean;
    readonly isSigner: boolean | 'either';
    readonly isOptional: boolean;
    readonly docs: string[];
}
export type InstructionAccountNodeInput<TDefaultValue extends InstructionInputValueNode | undefined = InstructionInputValueNode | undefined> = Omit<PartialExcept<InstructionAccountNode<TDefaultValue>, 'isWritable' | 'isSigner'>, 'kind' | 'name'> & {
    readonly name: string;
};
export declare function instructionAccountNode<TDefaultValue extends InstructionInputValueNode | undefined = undefined>(input: InstructionAccountNodeInput<TDefaultValue>): InstructionAccountNode<TDefaultValue>;
export declare function instructionAccountNodeFromIdl(idl: IdlInstructionAccount): InstructionAccountNode;
