import { IdlInstructionArg } from '../idl';
import { MainCaseString } from '../shared';
import { InstructionInputValueNode } from './contextualValueNodes';
import { TypeNode } from './typeNodes';
export interface InstructionArgumentNode<TDefaultValue extends InstructionInputValueNode | undefined = InstructionInputValueNode | undefined> {
    readonly kind: 'instructionArgumentNode';
    readonly type: TypeNode;
    readonly defaultValue?: TDefaultValue;
    readonly name: MainCaseString;
    readonly docs: string[];
    readonly defaultValueStrategy?: 'optional' | 'omitted';
}
export type InstructionArgumentNodeInput<TDefaultValue extends InstructionInputValueNode | undefined = InstructionInputValueNode | undefined> = {
    readonly name: string;
    readonly type: TypeNode;
    readonly docs?: string[];
    readonly defaultValue?: TDefaultValue;
    readonly defaultValueStrategy?: 'optional' | 'omitted';
};
export declare function instructionArgumentNode<TDefaultValue extends InstructionInputValueNode | undefined = undefined>(input: InstructionArgumentNodeInput<TDefaultValue>): InstructionArgumentNode<TDefaultValue>;
export declare function instructionArgumentNodeFromIdl(idl: IdlInstructionArg): InstructionArgumentNode;
export declare function structTypeNodeFromInstructionArgumentNodes(nodes: InstructionArgumentNode[]): import("src/nodes/typeNodes/StructTypeNode").StructTypeNode<(import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<TypeNode, import("src/nodes/valueNodes/ArrayValueNode").ArrayValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | import("src/nodes/valueNodes/BytesValueNode").BytesValueNode | import("src/nodes/valueNodes/BooleanValueNode").BooleanValueNode | import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode> | import("src/nodes/valueNodes/EnumValueNode").EnumValueNode<import("src").DefinedTypeLinkNode, import("src/nodes/valueNodes/StructValueNode").StructValueNode<import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]> | import("src/nodes/valueNodes/TupleValueNode").TupleValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | undefined> | import("src/nodes/valueNodes/MapValueNode").MapValueNode<import("src/nodes/valueNodes/MapEntryValueNode").MapEntryValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]> | import("src/nodes/valueNodes/NoneValueNode").NoneValueNode | import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/valueNodes/SetValueNode").SetValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | import("src/nodes/valueNodes/SomeValueNode").SomeValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode> | import("src/nodes/valueNodes/StructValueNode").StructValueNode<import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]> | import("src/nodes/valueNodes/TupleValueNode").TupleValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | import("src/nodes/valueNodes/PublicKeyValueNode").PublicKeyValueNode | import("src/nodes/valueNodes/StringValueNode").StringValueNode> | import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<TypeNode, undefined>)[]>;
export declare function structFieldTypeNodeFromInstructionArgumentNode(node: InstructionArgumentNode): import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<TypeNode, import("src/nodes/valueNodes/ArrayValueNode").ArrayValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | import("src/nodes/valueNodes/BytesValueNode").BytesValueNode | import("src/nodes/valueNodes/BooleanValueNode").BooleanValueNode | import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode> | import("src/nodes/valueNodes/EnumValueNode").EnumValueNode<import("src").DefinedTypeLinkNode, import("src/nodes/valueNodes/StructValueNode").StructValueNode<import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]> | import("src/nodes/valueNodes/TupleValueNode").TupleValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | undefined> | import("src/nodes/valueNodes/MapValueNode").MapValueNode<import("src/nodes/valueNodes/MapEntryValueNode").MapEntryValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]> | import("src/nodes/valueNodes/NoneValueNode").NoneValueNode | import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/valueNodes/SetValueNode").SetValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | import("src/nodes/valueNodes/SomeValueNode").SomeValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode> | import("src/nodes/valueNodes/StructValueNode").StructValueNode<import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]> | import("src/nodes/valueNodes/TupleValueNode").TupleValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | import("src/nodes/valueNodes/PublicKeyValueNode").PublicKeyValueNode | import("src/nodes/valueNodes/StringValueNode").StringValueNode> | import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<TypeNode, undefined>;
