import type { ProgramLinkNode } from '../linkNodes/ProgramLinkNode';
import { ValueNode } from '../valueNodes/ValueNode';
import type { AccountBumpValueNode } from './AccountBumpValueNode';
import type { AccountValueNode } from './AccountValueNode';
import type { ArgumentValueNode } from './ArgumentValueNode';
import type { ConditionalValueNode } from './ConditionalValueNode';
import type { IdentityValueNode } from './IdentityValueNode';
import type { PayerValueNode } from './PayerValueNode';
import type { PdaSeedValueNode } from './PdaSeedValueNode';
import type { PdaValueNode } from './PdaValueNode';
import type { ProgramIdValueNode } from './ProgramIdValueNode';
import type { ResolverValueNode } from './ResolverValueNode';
export type StandaloneContextualValueNode = AccountBumpValueNode | AccountValueNode | ArgumentValueNode | ConditionalValueNode | IdentityValueNode | PayerValueNode | PdaValueNode | ProgramIdValueNode | ResolverValueNode;
export declare const STANDALONE_CONTEXTUAL_VALUE_NODE_KINDS: ("accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode")[];
export type RegisteredContextualValueNode = StandaloneContextualValueNode | PdaSeedValueNode;
export declare const REGISTERED_CONTEXTUAL_VALUE_NODE_KINDS: ("accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode" | "pdaSeedValueNode")[];
export type ContextualValueNode = StandaloneContextualValueNode;
export declare const CONTEXTUAL_VALUE_NODES: ("accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode")[];
export type InstructionInputValueNode = ValueNode | ContextualValueNode | ProgramLinkNode;
export declare const INSTRUCTION_INPUT_VALUE_NODE: ("arrayValueNode" | "bytesValueNode" | "booleanValueNode" | "constantValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode" | "programLinkNode")[];
