import type { NestedTypeNode } from './NestedTypeNode';
import type { IdlTypeEnumVariant } from '../../idl';
import { MainCaseString } from '../../shared';
import { StructTypeNode } from './StructTypeNode';
export interface EnumStructVariantTypeNode<TStruct extends NestedTypeNode<StructTypeNode> = NestedTypeNode<StructTypeNode>> {
    readonly kind: 'enumStructVariantTypeNode';
    readonly struct: TStruct;
    readonly name: MainCaseString;
    readonly discriminator?: number;
}
export declare function enumStructVariantTypeNode<TStruct extends NestedTypeNode<StructTypeNode>>(name: string, struct: TStruct, discriminator?: number): EnumStructVariantTypeNode<TStruct>;
export declare function enumStructVariantTypeNodeFromIdl(idl: IdlTypeEnumVariant): EnumStructVariantTypeNode<StructTypeNode>;
