import type { IdlTypeMap } from '../../idl';
import { CountNode, PrefixedCountNode } from '../countNodes';
import { NumberTypeNode } from './NumberTypeNode';
import { TypeNode } from './TypeNode';
export interface MapTypeNode<TKey extends TypeNode = TypeNode, TValue extends TypeNode = TypeNode, TCount extends CountNode = CountNode> {
    readonly kind: 'mapTypeNode';
    readonly key: TKey;
    readonly value: TValue;
    readonly count: TCount;
    readonly idlMap: 'hashMap' | 'bTreeMap';
}
export declare function mapTypeNode<TKey extends TypeNode = TypeNode, TValue extends TypeNode = TypeNode, TCount extends CountNode = PrefixedCountNode<NumberTypeNode<'u32'>>>(key: TKey, value: TValue, count?: TCount, idlMap?: MapTypeNode['idlMap']): MapTypeNode<TKey, TValue, TCount>;
export declare function mapTypeNodeFromIdl(idl: IdlTypeMap): MapTypeNode;
