export type NumberFormat = 'u8' | 'u16' | 'u32' | 'u64' | 'u128' | 'i8' | 'i16' | 'i32' | 'i64' | 'i128' | 'f32' | 'f64';
export interface NumberTypeNode<TFormat extends NumberFormat = NumberFormat> {
    readonly kind: 'numberTypeNode';
    readonly format: TFormat;
    readonly endian: 'le' | 'be';
}
export declare function numberTypeNode<TFormat extends NumberFormat = NumberFormat>(format: TFormat, endian?: 'le' | 'be'): NumberTypeNode<TFormat>;
export declare function isSignedInteger(node: NumberTypeNode): boolean;
export declare function isUnsignedInteger(node: NumberTypeNode): boolean;
export declare function isInteger(node: NumberTypeNode): boolean;
export declare function isDecimal(node: NumberTypeNode): boolean;
