import type { IdlTypeOption } from '../../idl';
import { NestedTypeNode } from './NestedTypeNode';
import { NumberTypeNode } from './NumberTypeNode';
import { TypeNode } from './TypeNode';
export interface OptionTypeNode<TItem extends TypeNode = TypeNode, TPrefix extends NestedTypeNode<NumberTypeNode> = NestedTypeNode<NumberTypeNode>> {
    readonly kind: 'optionTypeNode';
    readonly item: TItem;
    readonly prefix: TPrefix;
    readonly fixed: boolean;
    readonly idlOption: 'option' | 'coption';
}
export declare function optionTypeNode<TItem extends TypeNode, TPrefix extends NestedTypeNode<NumberTypeNode> = NumberTypeNode<'u8'>>(item: TItem, options?: {
    readonly prefix?: TPrefix;
    readonly fixed?: boolean;
    readonly idlOption?: OptionTypeNode['idlOption'];
}): OptionTypeNode<TItem, TPrefix>;
export declare function optionTypeNodeFromIdl(idl: IdlTypeOption): OptionTypeNode;
