import { IdlType } from '../../idl';
import { DefinedTypeLinkNode } from '../linkNodes/DefinedTypeLinkNode';
import { AmountTypeNode } from './AmountTypeNode';
import { ArrayTypeNode } from './ArrayTypeNode';
import { BooleanTypeNode } from './BooleanTypeNode';
import { BytesTypeNode } from './BytesTypeNode';
import { DateTimeTypeNode } from './DateTimeTypeNode';
import { EnumEmptyVariantTypeNode } from './EnumEmptyVariantTypeNode';
import { EnumStructVariantTypeNode } from './EnumStructVariantTypeNode';
import { EnumTupleVariantTypeNode } from './EnumTupleVariantTypeNode';
import { EnumTypeNode } from './EnumTypeNode';
import { FixedSizeTypeNode } from './FixedSizeTypeNode';
import { HiddenPrefixTypeNode } from './HiddenPrefixTypeNode';
import { HiddenSuffixTypeNode } from './HiddenSuffixTypeNode';
import { MapTypeNode } from './MapTypeNode';
import { NumberTypeNode } from './NumberTypeNode';
import { OptionTypeNode } from './OptionTypeNode';
import { PostOffsetTypeNode } from './PostOffsetTypeNode';
import { PreOffsetTypeNode } from './PreOffsetTypeNode';
import { PublicKeyTypeNode } from './PublicKeyTypeNode';
import { SentinelTypeNode } from './SentinelTypeNode';
import { SetTypeNode } from './SetTypeNode';
import { SizePrefixTypeNode } from './SizePrefixTypeNode';
import { SolAmountTypeNode } from './SolAmountTypeNode';
import { StringTypeNode } from './StringTypeNode';
import { StructFieldTypeNode } from './StructFieldTypeNode';
import { StructTypeNode } from './StructTypeNode';
import { TupleTypeNode } from './TupleTypeNode';
import { ZeroableOptionTypeNode } from './ZeroableOptionTypeNode';
export type StandaloneTypeNode = AmountTypeNode | ArrayTypeNode | BooleanTypeNode | BytesTypeNode | DateTimeTypeNode | EnumTypeNode | FixedSizeTypeNode | HiddenPrefixTypeNode | HiddenSuffixTypeNode | MapTypeNode | NumberTypeNode | OptionTypeNode | PostOffsetTypeNode | PreOffsetTypeNode | PublicKeyTypeNode | SentinelTypeNode | SetTypeNode | SizePrefixTypeNode | SolAmountTypeNode | StringTypeNode | StructTypeNode | TupleTypeNode | ZeroableOptionTypeNode;
export declare const STANDALONE_TYPE_NODE_KINDS: ("amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "fixedSizeTypeNode" | "hiddenPrefixTypeNode" | "hiddenSuffixTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "postOffsetTypeNode" | "preOffsetTypeNode" | "publicKeyTypeNode" | "sentinelTypeNode" | "setTypeNode" | "sizePrefixTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "zeroableOptionTypeNode")[];
export type RegisteredTypeNode = StandaloneTypeNode | StructFieldTypeNode | EnumEmptyVariantTypeNode | EnumStructVariantTypeNode | EnumTupleVariantTypeNode;
export declare const REGISTERED_TYPE_NODE_KINDS: ("amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "fixedSizeTypeNode" | "hiddenPrefixTypeNode" | "hiddenSuffixTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "postOffsetTypeNode" | "preOffsetTypeNode" | "publicKeyTypeNode" | "sentinelTypeNode" | "setTypeNode" | "sizePrefixTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "zeroableOptionTypeNode" | "structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode")[];
export type TypeNode = StandaloneTypeNode | DefinedTypeLinkNode;
export declare const TYPE_NODES: ("definedTypeLinkNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "fixedSizeTypeNode" | "hiddenPrefixTypeNode" | "hiddenSuffixTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "postOffsetTypeNode" | "preOffsetTypeNode" | "publicKeyTypeNode" | "sentinelTypeNode" | "setTypeNode" | "sizePrefixTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "zeroableOptionTypeNode")[];
export declare const createTypeNodeFromIdl: (idlType: IdlType) => TypeNode;
