import { Options as PrettierOptions } from 'prettier';
import { ImportFrom, LinkableDictionary, MainCaseString, RenderMap } from '../../shared';
import { CustomDataOptions, ParsedCustomDataOptions } from './customDataHelpers';
import { TypeManifestVisitor } from './getTypeManifestVisitor';
import { NameApi, NameTransformers } from './nameTransformers';
export type GetRenderMapOptions = {
    renderParentInstructions?: boolean;
    formatCode?: boolean;
    prettierOptions?: PrettierOptions;
    dependencyMap?: Record<ImportFrom, string>;
    asyncResolvers?: string[];
    nameTransformers?: Partial<NameTransformers>;
    nonScalarEnums?: string[];
    internalNodes?: string[];
    customAccountData?: CustomDataOptions[];
    customInstructionData?: CustomDataOptions[];
};
export type GlobalFragmentScope = {
    nameApi: NameApi;
    linkables: LinkableDictionary;
    typeManifestVisitor: TypeManifestVisitor;
    asyncResolvers: MainCaseString[];
    nonScalarEnums: MainCaseString[];
    renderParentInstructions: boolean;
    customAccountData: ParsedCustomDataOptions;
    customInstructionData: ParsedCustomDataOptions;
};
export declare function getRenderMapVisitor(options?: GetRenderMapOptions): import("src/visitors/visitor").Visitor<RenderMap, "rootNode" | "programNode" | "pdaNode" | "accountNode" | "instructionNode" | "definedTypeNode">;
