export type NameTransformerHelpers = {
    capitalize: (name: string) => string;
    titleCase: (name: string) => string;
    pascalCase: (name: string) => string;
    camelCase: (name: string) => string;
    kebabCase: (name: string) => string;
    snakeCase: (name: string) => string;
};
export type NameTransformer = (name: string, helpers: NameTransformerHelpers) => string;
export type NameTransformerKey = 'dataType' | 'dataArgsType' | 'encoderFunction' | 'decoderFunction' | 'codecFunction' | 'pdaSeedsType' | 'pdaFindFunction' | 'accountType' | 'accountMaybeType' | 'accountDataType' | 'accountDecodeFunction' | 'accountFetchFunction' | 'accountFetchAllFunction' | 'accountFetchMaybeFunction' | 'accountFetchAllMaybeFunction' | 'accountFetchFromSeedsFunction' | 'accountFetchMaybeFromSeedsFunction' | 'accountGetSizeFunction' | 'enumVariant' | 'discriminatedUnionDiscriminator' | 'discriminatedUnionVariant' | 'discriminatedUnionFunction' | 'isDiscriminatedUnionFunction' | 'instructionAsyncInputType' | 'instructionSyncInputType' | 'instructionType' | 'instructionDataType' | 'instructionExtraType' | 'instructionAsyncFunction' | 'instructionSyncFunction' | 'instructionParsedType' | 'instructionParseFunction' | 'programType' | 'programAddressConstant' | 'programCreateFunction' | 'programAccountsEnum' | 'programAccountsEnumVariant' | 'programAccountsIdentifierFunction' | 'programInstructionsEnum' | 'programInstructionsEnumVariant' | 'programInstructionsIdentifierFunction' | 'programInstructionsParsedUnionType' | 'programErrorClass' | 'programErrorCodeEnum' | 'programErrorCodeMap' | 'programGetErrorFromCodeFunction' | 'resolverFunction';
export type NameTransformers = Record<NameTransformerKey, NameTransformer>;
export type NameApi = Record<NameTransformerKey, (name: string) => string>;
export declare function getNameApi(transformers: NameTransformers): NameApi;
export declare const DEFAULT_NAME_TRANSFORMERS: NameTransformers;
