import type { ImportFrom } from '../../shared';
import { JavaScriptTypeManifest } from './getTypeManifestVisitor';
export declare class JavaScriptImportMap {
    protected readonly _imports: Map<ImportFrom, Set<string>>;
    protected readonly _aliases: Map<ImportFrom, Record<string, string>>;
    add(module: ImportFrom, imports: string | string[] | Set<string>): JavaScriptImportMap;
    remove(module: ImportFrom, imports: string | string[] | Set<string>): JavaScriptImportMap;
    mergeWith(...others: JavaScriptImportMap[]): JavaScriptImportMap;
    mergeWithManifest(manifest: JavaScriptTypeManifest): JavaScriptImportMap;
    addAlias(module: ImportFrom, name: string, alias: string): JavaScriptImportMap;
    isEmpty(): boolean;
    toString(dependencies: Record<ImportFrom, string>): string;
}
