import { LinkableDictionary, MainCaseString } from '../../shared';
import { Visitor } from '../../visitors';
import { JavaScriptImportMap } from './JavaScriptImportMap';
import { ParsedCustomDataOptions } from './customDataHelpers';
export type JavaScriptTypeManifest = {
    isEnum: boolean;
    strictType: string;
    strictImports: JavaScriptImportMap;
    looseType: string;
    looseImports: JavaScriptImportMap;
    serializer: string;
    serializerImports: JavaScriptImportMap;
    value: string;
    valueImports: JavaScriptImportMap;
};
export declare function getTypeManifestVisitor(input: {
    linkables: LinkableDictionary;
    nonScalarEnums: MainCaseString[];
    customAccountData: ParsedCustomDataOptions;
    customInstructionData: ParsedCustomDataOptions;
    parentName?: {
        strict: string;
        loose: string;
    };
}): Visitor<JavaScriptTypeManifest, "arrayValueNode" | "bytesValueNode" | "booleanValueNode" | "constantValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "definedTypeLinkNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "fixedSizeTypeNode" | "hiddenPrefixTypeNode" | "hiddenSuffixTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "postOffsetTypeNode" | "preOffsetTypeNode" | "publicKeyTypeNode" | "sentinelTypeNode" | "setTypeNode" | "sizePrefixTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "zeroableOptionTypeNode" | "structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode" | "mapEntryValueNode" | "structFieldValueNode" | "accountNode" | "instructionNode" | "definedTypeNode">;
