import type { ImportFrom } from '../../shared';
import { RustTypeManifest } from './getTypeManifestVisitor';
export declare class RustImportMap {
    protected readonly _imports: Set<string>;
    protected readonly _aliases: Map<string, string>;
    get imports(): Set<string>;
    get aliases(): Map<string, string>;
    add(imports: string | string[] | Set<string>): RustImportMap;
    remove(imports: string | string[] | Set<string>): RustImportMap;
    mergeWith(...others: RustImportMap[]): RustImportMap;
    mergeWithManifest(manifest: RustTypeManifest): RustImportMap;
    addAlias(importName: string, alias: string): RustImportMap;
    isEmpty(): boolean;
    resolveDependencyMap(dependencies: Record<ImportFrom, string>): RustImportMap;
    toString(dependencies: Record<ImportFrom, string>): string;
}
