import { Node } from '../nodes';
import { LogLevel } from './logs';
import { NodeStack } from './NodeStack';
export type ValidatorItem = {
    message: string;
    level: LogLevel;
    node: Node;
    stack: NodeStack;
};
export declare class ValidatorBag {
    readonly items: ValidatorItem[];
    constructor(items?: ValidatorItem[]);
    add(item: ValidatorItem): ValidatorBag;
    mergeWith(others: ValidatorBag[]): ValidatorBag;
    error(message: string, node: Node, stack: NodeStack): ValidatorBag;
    warn(message: string, node: Node, stack: NodeStack): ValidatorBag;
    info(message: string, node: Node, stack: NodeStack): ValidatorBag;
    trace(message: string, node: Node, stack: NodeStack): ValidatorBag;
    debug(message: string, node: Node, stack: NodeStack): ValidatorBag;
    orderByLevel(): ValidatorBag;
    log(): void;
}
