import { InstructionAccountNodeInput, InstructionArgumentNodeInput, InstructionInputValueNode, InstructionNodeInput } from '../nodes';
export type InstructionUpdates = {
    delete: true;
} | (InstructionMetadataUpdates & {
    accounts?: InstructionAccountUpdates;
    arguments?: InstructionArgumentUpdates;
});
export type InstructionMetadataUpdates = Partial<Omit<InstructionNodeInput, 'accounts' | 'arguments' | 'extraArguments' | 'remainingAccounts' | 'byteDeltas' | 'discriminators' | 'subInstructions'>>;
export type InstructionAccountUpdates = Record<string, Partial<Omit<InstructionAccountNodeInput, 'defaultValue'>> & {
    defaultValue?: InstructionInputValueNode | null;
}>;
export type InstructionArgumentUpdates = Record<string, Partial<Omit<InstructionArgumentNodeInput, 'defaultValue'>> & {
    defaultValue?: InstructionInputValueNode | null;
}>;
export declare function updateInstructionsVisitor(map: Record<string, InstructionUpdates>): import("./visitor").Visitor<import("src/nodes/Node").Node | null, "arrayValueNode" | "bytesValueNode" | "booleanValueNode" | "constantValueNode" | "enumValueNode" | "mapValueNode" | "noneValueNode" | "numberValueNode" | "setValueNode" | "someValueNode" | "structValueNode" | "tupleValueNode" | "publicKeyValueNode" | "stringValueNode" | "accountBumpValueNode" | "accountValueNode" | "argumentValueNode" | "conditionalValueNode" | "identityValueNode" | "payerValueNode" | "pdaValueNode" | "programIdValueNode" | "resolverValueNode" | "pdaSeedValueNode" | "fixedCountNode" | "remainderCountNode" | "prefixedCountNode" | "constantDiscriminatorNode" | "fieldDiscriminatorNode" | "sizeDiscriminatorNode" | "programLinkNode" | "pdaLinkNode" | "accountLinkNode" | "definedTypeLinkNode" | "constantPdaSeedNode" | "variablePdaSeedNode" | "amountTypeNode" | "arrayTypeNode" | "booleanTypeNode" | "bytesTypeNode" | "dateTimeTypeNode" | "enumTypeNode" | "fixedSizeTypeNode" | "hiddenPrefixTypeNode" | "hiddenSuffixTypeNode" | "mapTypeNode" | "numberTypeNode" | "optionTypeNode" | "postOffsetTypeNode" | "preOffsetTypeNode" | "publicKeyTypeNode" | "sentinelTypeNode" | "setTypeNode" | "sizePrefixTypeNode" | "solAmountTypeNode" | "stringTypeNode" | "structTypeNode" | "tupleTypeNode" | "zeroableOptionTypeNode" | "structFieldTypeNode" | "enumEmptyVariantTypeNode" | "enumStructVariantTypeNode" | "enumTupleVariantTypeNode" | "mapEntryValueNode" | "structFieldValueNode" | "rootNode" | "programNode" | "pdaNode" | "accountNode" | "instructionAccountNode" | "instructionArgumentNode" | "instructionByteDeltaNode" | "instructionNode" | "instructionRemainingAccountsNode" | "errorNode" | "definedTypeNode">;
