import { NumberTypeNode } from '../../nodes';
import { RustImportMap } from './RustImportMap';
export type RustTypeManifest = {
    type: string;
    imports: RustImportMap;
    nestedStructs: string[];
};
export declare function getTypeManifestVisitor(): {
    setParentName: (name: string | null) => void;
    setNestedStruct: (value: boolean) => void;
    visitArrayValue: (node: import("src/nodes/valueNodes/ArrayValueNode").ArrayValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]>) => RustTypeManifest;
    visitBytesValue: (node: import("src/nodes/valueNodes/BytesValueNode").BytesValueNode) => RustTypeManifest;
    visitBooleanValue: (node: import("src/nodes/valueNodes/BooleanValueNode").BooleanValueNode) => RustTypeManifest;
    visitConstantValue: (node: import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>) => RustTypeManifest;
    visitEnumValue: (node: import("src/nodes/valueNodes/EnumValueNode").EnumValueNode<import("src/nodes/linkNodes/DefinedTypeLinkNode").DefinedTypeLinkNode, import("src/nodes/valueNodes/StructValueNode").StructValueNode<import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]> | import("src/nodes/valueNodes/TupleValueNode").TupleValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]> | undefined>) => RustTypeManifest;
    visitMapValue: (node: import("src/nodes/valueNodes/MapValueNode").MapValueNode<import("src/nodes/valueNodes/MapEntryValueNode").MapEntryValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]>) => RustTypeManifest;
    visitNoneValue: (node: import("src/nodes/valueNodes/NoneValueNode").NoneValueNode) => RustTypeManifest;
    visitNumberValue: (node: import("src/nodes/valueNodes/NumberValueNode").NumberValueNode) => RustTypeManifest;
    visitSetValue: (node: import("src/nodes/valueNodes/SetValueNode").SetValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]>) => RustTypeManifest;
    visitSomeValue: (node: import("src/nodes/valueNodes/SomeValueNode").SomeValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>) => RustTypeManifest;
    visitStructValue: (node: import("src/nodes/valueNodes/StructValueNode").StructValueNode<import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]>) => RustTypeManifest;
    visitTupleValue: (node: import("src/nodes/valueNodes/TupleValueNode").TupleValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode[]>) => RustTypeManifest;
    visitPublicKeyValue: (node: import("src/nodes/valueNodes/PublicKeyValueNode").PublicKeyValueNode) => RustTypeManifest;
    visitStringValue: (node: import("src/nodes/valueNodes/StringValueNode").StringValueNode) => RustTypeManifest;
    visitAccountBumpValue: (node: import("src/nodes/contextualValueNodes/AccountBumpValueNode").AccountBumpValueNode) => RustTypeManifest;
    visitAccountValue: (node: import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode) => RustTypeManifest;
    visitArgumentValue: (node: import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode) => RustTypeManifest;
    visitConditionalValue: (node: import("src/nodes/contextualValueNodes/ConditionalValueNode").ConditionalValueNode<import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined, import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined, import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>) => RustTypeManifest;
    visitIdentityValue: (node: import("src/nodes/contextualValueNodes/IdentityValueNode").IdentityValueNode) => RustTypeManifest;
    visitPayerValue: (node: import("src/nodes/contextualValueNodes/PayerValueNode").PayerValueNode) => RustTypeManifest;
    visitPdaValue: (node: import("src/nodes/contextualValueNodes/PdaValueNode").PdaValueNode<import("src/nodes/contextualValueNodes/PdaSeedValueNode").PdaSeedValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode>[]>) => RustTypeManifest;
    visitProgramIdValue: (node: import("src/nodes/contextualValueNodes/ProgramIdValueNode").ProgramIdValueNode) => RustTypeManifest;
    visitResolverValue: (node: import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>) => RustTypeManifest;
    visitPdaSeedValue: (node: import("src/nodes/contextualValueNodes/PdaSeedValueNode").PdaSeedValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode>) => RustTypeManifest;
    visitFixedCount: (node: import("src/nodes/countNodes/FixedCountNode").FixedCountNode) => RustTypeManifest;
    visitRemainderCount: (node: import("src/nodes/countNodes/RemainderCountNode").RemainderCountNode) => RustTypeManifest;
    visitPrefixedCount: (node: import("src/nodes/countNodes/PrefixedCountNode").PrefixedCountNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitConstantDiscriminator: (node: import("src/nodes/discriminatorNodes/ConstantDiscriminatorNode").ConstantDiscriminatorNode<import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>>) => RustTypeManifest;
    visitFieldDiscriminator: (node: import("src/nodes/discriminatorNodes/FieldDiscriminatorNode").FieldDiscriminatorNode) => RustTypeManifest;
    visitSizeDiscriminator: (node: import("src/nodes/discriminatorNodes/SizeDiscriminatorNode").SizeDiscriminatorNode) => RustTypeManifest;
    visitProgramLink: (node: import("src/nodes/linkNodes/ProgramLinkNode").ProgramLinkNode) => RustTypeManifest;
    visitPdaLink: (node: import("src/nodes/linkNodes/PdaLinkNode").PdaLinkNode) => RustTypeManifest;
    visitAccountLink: (node: import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode) => RustTypeManifest;
    visitDefinedTypeLink: (node: import("src/nodes/linkNodes/DefinedTypeLinkNode").DefinedTypeLinkNode) => RustTypeManifest;
    visitConstantPdaSeed: (node: import("src/nodes/pdaSeedNodes/ConstantPdaSeedNode").ConstantPdaSeedNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | import("src/nodes/contextualValueNodes/ProgramIdValueNode").ProgramIdValueNode>) => RustTypeManifest;
    visitVariablePdaSeed: (node: import("src/nodes/pdaSeedNodes/VariablePdaSeedNode").VariablePdaSeedNode<import("src/nodes/typeNodes/TypeNode").TypeNode>) => RustTypeManifest;
    visitAmountType: (node: import("src/nodes/typeNodes/AmountTypeNode").AmountTypeNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitArrayType: (node: import("src/nodes/typeNodes/ArrayTypeNode").ArrayTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/countNodes/CountNode").RegisteredCountNode>) => RustTypeManifest;
    visitBooleanType: (node: import("src/nodes/typeNodes/BooleanTypeNode").BooleanTypeNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitBytesType: (node: import("src/nodes/typeNodes/BytesTypeNode").BytesTypeNode) => RustTypeManifest;
    visitDateTimeType: (node: import("src/nodes/typeNodes/DateTimeTypeNode").DateTimeTypeNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitEnumType: (node: import("src/nodes/typeNodes/EnumTypeNode").EnumTypeNode<import("src/nodes/typeNodes/EnumVariantTypeNode").EnumVariantTypeNode[], import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitFixedSizeType: (node: import("src/nodes/typeNodes/FixedSizeTypeNode").FixedSizeTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode>) => RustTypeManifest;
    visitHiddenPrefixType: (node: import("src/nodes/typeNodes/HiddenPrefixTypeNode").HiddenPrefixTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]>) => RustTypeManifest;
    visitHiddenSuffixType: (node: import("src/nodes/typeNodes/HiddenSuffixTypeNode").HiddenSuffixTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>[]>) => RustTypeManifest;
    visitMapType: (node: import("src/nodes/typeNodes/MapTypeNode").MapTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/countNodes/CountNode").RegisteredCountNode>) => RustTypeManifest;
    visitNumberType: (node: NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>) => RustTypeManifest;
    visitOptionType: (node: import("src/nodes/typeNodes/OptionTypeNode").OptionTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitPostOffsetType: (node: import("src/nodes/typeNodes/PostOffsetTypeNode").PostOffsetTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode>) => RustTypeManifest;
    visitPreOffsetType: (node: import("src/nodes/typeNodes/PreOffsetTypeNode").PreOffsetTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode>) => RustTypeManifest;
    visitPublicKeyType: (node: import("src/nodes/typeNodes/PublicKeyTypeNode").PublicKeyTypeNode) => RustTypeManifest;
    visitSentinelType: (node: import("src/nodes/typeNodes/SentinelTypeNode").SentinelTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>>) => RustTypeManifest;
    visitSetType: (node: import("src/nodes/typeNodes/SetTypeNode").SetTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/countNodes/CountNode").RegisteredCountNode>) => RustTypeManifest;
    visitSizePrefixType: (node: import("src/nodes/typeNodes/SizePrefixTypeNode").SizePrefixTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitSolAmountType: (node: import("src/nodes/typeNodes/SolAmountTypeNode").SolAmountTypeNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<NumberTypeNode<import("src/nodes/typeNodes/NumberTypeNode").NumberFormat>>>) => RustTypeManifest;
    visitStringType: (node: import("src/nodes/typeNodes/StringTypeNode").StringTypeNode<import("src/nodes/typeNodes/StringTypeNode").StringEncoding>) => RustTypeManifest;
    visitStructType: (node: import("src/nodes/typeNodes/StructTypeNode").StructTypeNode<import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined>[]>) => RustTypeManifest;
    visitTupleType: (node: import("src/nodes/typeNodes/TupleTypeNode").TupleTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode[]>) => RustTypeManifest;
    visitZeroableOptionType: (node: import("src/nodes/typeNodes/ZeroableOptionTypeNode").ZeroableOptionTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ConstantValueNode").ConstantValueNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode> | undefined>) => RustTypeManifest;
    visitStructFieldType: (node: import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined>) => RustTypeManifest;
    visitEnumEmptyVariantType: (node: import("src/nodes/typeNodes/EnumEmptyVariantTypeNode").EnumEmptyVariantTypeNode) => RustTypeManifest;
    visitEnumStructVariantType: (node: import("src/nodes/typeNodes/EnumStructVariantTypeNode").EnumStructVariantTypeNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<import("src/nodes/typeNodes/StructTypeNode").StructTypeNode<import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined>[]>>>) => RustTypeManifest;
    visitEnumTupleVariantType: (node: import("src/nodes/typeNodes/EnumTupleVariantTypeNode").EnumTupleVariantTypeNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<import("src/nodes/typeNodes/TupleTypeNode").TupleTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode[]>>>) => RustTypeManifest;
    visitMapEntryValue: (node: import("src/nodes/valueNodes/MapEntryValueNode").MapEntryValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>) => RustTypeManifest;
    visitStructFieldValue: (node: import("src/nodes/valueNodes/StructFieldValueNode").StructFieldValueNode<import("src/nodes/valueNodes/ValueNode").StandaloneValueNode>) => RustTypeManifest;
    visitRoot: (node: import("src/nodes/RootNode").RootNode<import("src/nodes/ProgramNode").ProgramNode<import("src/nodes/PdaNode").PdaNode<import("src/nodes/pdaSeedNodes/PdaSeedNode").RegisteredPdaSeedNode[]>[], import("src/nodes/AccountNode").AccountNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<import("src/nodes/typeNodes/StructTypeNode").StructTypeNode<import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined>[]>>, import("src/nodes/linkNodes/PdaLinkNode").PdaLinkNode | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined>[], import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[], import("src/nodes/DefinedTypeNode").DefinedTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode>[], import("src/nodes/ErrorNode").ErrorNode[]>, import("src/nodes/ProgramNode").ProgramNode<import("src/nodes/PdaNode").PdaNode<import("src/nodes/pdaSeedNodes/PdaSeedNode").RegisteredPdaSeedNode[]>[], import("src/nodes/AccountNode").AccountNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<import("src/nodes/typeNodes/StructTypeNode").StructTypeNode<import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined>[]>>, import("src/nodes/linkNodes/PdaLinkNode").PdaLinkNode | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined>[], import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[], import("src/nodes/DefinedTypeNode").DefinedTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode>[], import("src/nodes/ErrorNode").ErrorNode[]>[]>) => RustTypeManifest;
    visitProgram: (node: import("src/nodes/ProgramNode").ProgramNode<import("src/nodes/PdaNode").PdaNode<import("src/nodes/pdaSeedNodes/PdaSeedNode").RegisteredPdaSeedNode[]>[], import("src/nodes/AccountNode").AccountNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<import("src/nodes/typeNodes/StructTypeNode").StructTypeNode<import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined>[]>>, import("src/nodes/linkNodes/PdaLinkNode").PdaLinkNode | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined>[], import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[], import("src/nodes/DefinedTypeNode").DefinedTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode>[], import("src/nodes/ErrorNode").ErrorNode[]>) => RustTypeManifest;
    visitPda: (node: import("src/nodes/PdaNode").PdaNode<import("src/nodes/pdaSeedNodes/PdaSeedNode").RegisteredPdaSeedNode[]>) => RustTypeManifest;
    visitAccount: (node: import("src/nodes/AccountNode").AccountNode<import("src/nodes/typeNodes/NestedTypeNode").NestedTypeNode<import("src/nodes/typeNodes/StructTypeNode").StructTypeNode<import("src/nodes/typeNodes/StructFieldTypeNode").StructFieldTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode, import("src/nodes/valueNodes/ValueNode").StandaloneValueNode | undefined>[]>>, import("src/nodes/linkNodes/PdaLinkNode").PdaLinkNode | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined>) => RustTypeManifest;
    visitInstructionAccount: (node: import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>) => RustTypeManifest;
    visitInstructionArgument: (node: import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>) => RustTypeManifest;
    visitInstructionByteDelta: (node: import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>) => RustTypeManifest;
    visitInstruction: (node: import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, import("src/nodes/InstructionNode").InstructionNode<import("src/nodes/InstructionAccountNode").InstructionAccountNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[], import("src/nodes/InstructionArgumentNode").InstructionArgumentNode<import("src/nodes/contextualValueNodes/ContextualValueNode").InstructionInputValueNode | undefined>[] | undefined, import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/InstructionByteDeltaNode").InstructionByteDeltaNode<import("src/nodes/valueNodes/NumberValueNode").NumberValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/linkNodes/AccountLinkNode").AccountLinkNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>[] | undefined, import("src/nodes/discriminatorNodes/DiscriminatorNode").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>) => RustTypeManifest;
    visitInstructionRemainingAccounts: (node: import("src/nodes/InstructionRemainingAccountsNode").InstructionRemainingAccountsNode<import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode | import("src/nodes/contextualValueNodes/ResolverValueNode").ResolverValueNode<(import("src/nodes/contextualValueNodes/AccountValueNode").AccountValueNode | import("src/nodes/contextualValueNodes/ArgumentValueNode").ArgumentValueNode)[]>>) => RustTypeManifest;
    visitError: (node: import("src/nodes/ErrorNode").ErrorNode) => RustTypeManifest;
    visitDefinedType: (node: import("src/nodes/DefinedTypeNode").DefinedTypeNode<import("src/nodes/typeNodes/TypeNode").TypeNode>) => RustTypeManifest;
};
